#!/bin/sh

die () {
   echo "*** mkconfig.sh: $*" 1>&2
   exit 1
}

[ -f makefile ] || die "can not find 'makefile'"

config=$1

# update config if git commit id changes
if [ -f $config ]; then
  commit_conf=`grep BTOR_ID $config | cut -d ' ' -f 3 | grep -o -e '[0-9a-z]\+'`
  commit_cur=`./getgitid.sh`
  if [ "$commit_conf" = "$commit_cur" ]; then
    exit
  fi
fi

cat > $config <<EOF
/*************************************************************/
/* Automatically generated by './mkconfig.sh': do note edit! */
/*************************************************************/
EOF

if [ ! x"`grep '^CC=gcc$' makefile`" =  x ]
then
  patchgccversion="`gcc --version|head -1|sed -e 's/,/ /g'`"
  patchgccversion="s,gcc,$patchgccversion,g"
else
  patchgccversion="s,DUMMY,DUMMY,"
fi

sed \
  -e '/^C[A-Z]*=/!d' \
  -e 's,^,#define BTOR_,' \
  -e 's,= *, ",' \
  -e 's,$,",' \
  makefile | sed -e "$patchgccversion" >> $config

curpath=`pwd`
BTOR_DEF_DATE="Wed Mar  8 14:20:04 CET 2017"
BTOR_DEF_VERSION="2.4.1"
BTOR_DEF_ID="a5b1ac38730acbf21d02b73fbafa81ffb5a326bd"

echo "#define BTOR_OS \"`uname -srmn`\"" >> $config 
echo "#define BTOR_COMPILED \"`date`\"" >> $config
echo "#define BTOR_SRC_DIR   \"$curpath/\"" >> $config
echo "#define BTOR_BIN_DIR   \"$curpath/bin/\"" >> $config
echo "#define BTOR_BUILD_DIR \"$curpath/build/\"" >> $config
echo "#define BTOR_TEST_DIR  \"$curpath/src/tests/\"" >> $config
echo "#define BTOR_LOG_DIR   \"$curpath/src/tests/log/\"" >> $config
echo "#define BTOR_CONTRIB_DIR \"$curpath/contrib/\"" >> $config
echo "#define BTOR_RELEASED \"$BTOR_DEF_DATE\"" >> $config
echo "#define BTOR_VERSION \"$BTOR_DEF_VERSION\"" >> $config
echo "#define BTOR_ID \"$BTOR_DEF_ID\"" >> $config
